Unit Algebra;

Interface

Procedure Fraction(X,Eps:extended; Var Numerator,Denomerator:longint);
{ ।⠢ . ᫠   ஡  . 筮 }
Function SqrSum(N:longint; Var I1,I2:longint):boolean;
{ ।⠢, ᫨  , ᫠   㬬 ⮢ }
Procedure CancelOut(Var I,J:longint);
{ ᮪饭 ஡ I/J }
function IsPrime(N:longint):boolean;
{ True ᫨ N - ⮥ ᫮ }
procedure ReverseNum(var N:longint);
{ 饭 ⥫쭮 ᫠, e.g. 123->321 }

  {    }

function Factorial(N:word):extended;
{ 䠪ਠ N! }
function Permutation(N,K:word):extended;
{ N!/(N-K)! - ⢮  K- ⠭
  N-⭮ ⢠; K<=N }
function Combination(N,K:word):extended;
{ N!/[(N-K)!*K!] - ⢮  K- 
  N-⭮ ⢠; K<=N }

Implementation

Procedure Fraction(X,Eps:extended; Var Numerator,Denomerator:longint);
Var p,q,p0,p1,q0,q1,ak:longint; B:boolean; l,k1:extended;
Begin
 p0:=1;
 p1:=Trunc(X);
 q0:=0; q1:=1;
 l:=Frac(X);
 B:=False;

 Repeat
  k1:=1/l;
  l:=Frac(k1);
  ak:=Trunc(k1);
  p:=ak*p1+p0;
  q:=ak*q1+q0;

  If Abs(p/q-X)>Eps then begin
   p0:=p1; p1:=p;
   q0:=q1; q1:=q
  end
  else B:=True
 until B;
 Numerator:=p;
 Denomerator:=q
End;

Function SqrSum(N:longint; Var I1,I2:longint):boolean;
Begin
 SqrSum:=True;
 I1:=1;
 While 2*I1*I1<=N do begin
  I2:=Round(Sqrt(N-I1*I1));
  If I1*I1+I2*I2=N then exit;
  Inc(I1)
 end;
 SqrSum:=False
End;

Procedure CancelOut(Var I,J:longint);
Var N,K:longint;
Begin
 N:=1;
 While N<=I do begin
  K:=N*I div J;
  If K*J=N*I then begin
   I:=K; J:=N; break;
  end;
  Inc(N)
 end;
End;

function IsPrime(N:longint):boolean;assembler;
{ True ᫨ N - ⮥ ᫮ }
asm
 db 66h,8bh,46h,06h  { mov eax,N }
 db 66h; mov bx,ax
 { ஢ઠ   2 }
 db 66h,25h,03h,00,00,00 { and eax,11b }
 db 66h,3dh,02h,00,00,00 { cmp eax,10b }
 jne @1 {   2? }
 xor ax,ax {  }
 jmp @exit
@1:
 { ஢ઠ   3 }
 db 66h; mov ax,bx
 db 66h,99h { cdq }
 db 66h,0b9h,03h,00,00,00 { mov ecx,3 }
 db 66h; div cx
 or dx,dx
 jne @2  {    3 }
 xor ax,ax
 db 66h,83h,0fbh,03h { cmp ebx,3 }
 jne @exit
 inc ax  { N=3 - ⮥ }
 jmp @exit
@2:
 { ஢ઠ   5 }
 db 66h; mov ax,bx
 db 66h,99h { cdq }
 db 66h,0b9h,05h,00,00,00 { mov ecx,5 }
 db 66h; div cx
 or dx,dx
 jne @3  {    5 }
 xor ax,ax
 db 66h,83h,0fbh,05h { cmp ebx,5 }
 jne @exit
 inc ax  { N=5 - ⮥ }
 jmp @exit
@3:
 { ஢塞  ⥫  7+2  sqrt(N) }
 fild N
 fsqrt
 fistp N
 fwait
 db 66h,0b9h,07h,00,00,00 { mov ecx,7 } { k=7 }
 db 66h,8bh,76h,06h { mov esi,N }
@4:
 { while k<sqrt(N) do begin }
 db 66h; cmp cx,si
 jae @5
 db 66h; mov ax,bx
 db 66h; inc cx { k=k+2 }
 db 66h; inc cx
 db 66h; div cx
 db 66h; or dx,dx { N mod k =0 ? }
 jnz @4
 xor ax,ax
 jmp @exit
@5:
 mov ax,1
@exit:
end;

procedure ReverseNum(var N:longint);assembler;
{ 饭 ⥫쭮 ᫠, e.g. 123->321 }
{ x:=N; y:=0;
  while x>0 do begin
   y:=10*y+(x mod 10);
   x:=x div 10
  end;
  Result - in y  }
asm
 les di,N
 db 26h,66h,8bh,0dh { mov ecx,es:[di] }
 db 66h; xor ax,ax
 db 66h,0beh,0ah,00,00,00 { mov esi,10 }
@1:
 db 66h,83h,0f9h,00 { cmp ecx,0 }
 jle @exit
 db 66h; mul si
 db 66h; mov bx,ax
 db 66h; mov ax,cx
 db 66h; div si
 db 66h; add bx,dx
 db 66h; mov cx,ax
 db 66h; mov ax,bx
 jmp @1
@exit:
 db 26h,66h,89h,1dh { mov es:[di],ebx }
end;

function Factorial(N:word):extended;assembler;
{ 䠪ਠ N! }
var Tmp:word;
asm
 fld1
 mov cx,N
 cmp cx,1
 jle @exit
 mov Tmp,cx
 dec cx
@1:
 fimul Tmp
 dec Tmp
 loop @1
@exit:
end;

function Permutation(N,K:word):extended;assembler;
{ N!/(N-K)! - ⢮  K- ⠭
  N-⭮ ⢠; K<=N }
var Tmp:word;
asm
 fld1
 mov cx,K
 mov ax,N
 sub ax,cx
 inc ax
 jle @exit
 mov Tmp,ax
@1:
 fimul Tmp
 inc Tmp
 loop @1
@exit:
end;

function Combination(N,K:word):extended;assembler;
{ N!/[(N-K)!*K!] - ⢮  K- 
  N-⭮ ⢠; K<=N }
var Tmp:word;
asm
 fld1
 mov cx,K
 mov ax,N
 mov dx,ax
 shr dx,1   { dx=N/2 }
 cmp dx,cx
 jl @5
 { 砩 N/2>=K }
{ - (N-K+1)*(N-K+2)*...*N  - K ࠧ }
 sub ax,cx
 inc ax    { ax=N-K+1 }
 mov Tmp,ax
@1:
 fimul Tmp
 inc Tmp
 loop @1
@2:
 { - K! }
 fld1
 mov cx,K
 cmp cx,1
 jle @4
 mov Tmp,cx
 dec cx
@3:
 fimul Tmp
 dec Tmp
 loop @3
@4:
 {  (N-K+1)*(N-K+2)*...*N  K! }
 fdivp
 jmp @exit
 { 砩 N/2<K }
@5:
 sub ax,cx  { ax=N-K }
 mov dx,ax
 inc cx     { cx=K+1 }
 xchg ax,cx
 mov Tmp,ax
{ - (K+1)*(K+2)*...*N   - N-K ࠧ }
@6:
 fimul Tmp
 inc Tmp
 loop @6
{ - (N-K)! }
 fld1
 cmp dx,1
 jle @8
 mov cx,dx  { cx=N-K }
 mov Tmp,cx
 dec cx
@7:
 fimul Tmp
 dec Tmp
 loop @7
@8:
 {  (K+1)*(K+2)*...*N  (N-K)! }
 fdivp
@exit:
end;

Var Seed1:word;

Procedure RandInit1;assembler; { Seeds rand from the DOS clock }
asm
 mov ah,2ch
 int 21h
 mov Seed1,dx
end;

Function Rand1:integer;assembler;
{ returns a 16 bit semi-poor quality pseudo-random number in AX }
Const
 k1=9821; k2=1;
asm
 mov ax,Seed1
 mov bx,k1
 imul bx
 add ax,k2
 mov Seed1,ax
 ror al,1
 rol ah,1
end;

End.
