{ (c) Copyright 1995,1997 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit Matrdef;
{$B-,F+,A+,N+,R-,S-,V-,I-,G+,X+,T-}

Interface
Uses Objects;

Type
 MatrixType=0..16;
 Float=extended;

Const
 GeneralM=4;    { 100b-騩        }
 SimmM=1;       { 001b-ᨬ }
 DiagM=3;       { 011b- }
 StringM=16;

 Epsmin:double=1.1102230246251565e-16;
 Eps:double=2.2204460492503131e-16;
 MaxExp=16383;
 MinExp=-16383;

Type

 PMatrix=^TMatrix;
 TMatrix=object(TObject)
  Lines:word;
  Cols:word;
  MatrixType:MatrixType;
  Changed:boolean;
  function GetMatrixType:MatrixType;
  function CellSize:word; virtual;
  procedure Fill(First,Last:word; Var Pat); virtual;
  procedure NewSize(NewLines:word; NewCols:word);virtual;
  function Loc(Line,Col:word):word; virtual;
  constructor Init(ALines,ACols:word; MType:MatrixType);
  procedure Put(Index:integer; Value:pointer);virtual;
  function Get(Index:integer):pointer;virtual;
  procedure Put2(Index1,Index2:integer; Value:pointer);virtual;
  function Get2(Index1,Index2:integer):pointer;virtual;
  procedure Assign(Matrix:PMatrix);virtual;
  function Compatible(Matrix:PMatrix):boolean;
 end;

 ByteBuffer=array[0..$FFF0] of char;
 PByteBuffer=^ByteBuffer;

 WordBuffer=array[0..$FFF0 div 2] of word;
 PWordBuffer=^WordBuffer;

 PStrMatrix=^TStrMatrix;
 TStrMatrix=object(TMatrix)
  BM:PByteBuffer;
  StrLen:byte;
  constructor Init(ALines:word; AStrLen:byte);
  procedure Put(Index:integer; Value:pointer);virtual;
  function Get(Index:integer):pointer;virtual;
  procedure NewSize(NewLines:word; NewCols:word);virtual;
  destructor Done;virtual;
 end;

 PMatrixF=^TMatrixF;
 TMatrixF=object(TMatrix)
  NormValue:extended;
  NormPower:integer;
  function GetNormPower:integer;
  procedure SetNormPower(MP:integer);
  function CellSize:word; virtual;
  procedure Normalize(Regim:byte);
  procedure NormalizePower(Regim:byte);
 end;

 FloatBuffer=array[0..5000] of extended;
 PFloatBuffer=^FloatBuffer;

 PolinomBuffer=array[0..20] of extended;
 PPolinomBuffer=^PolinomBuffer;

 PHeapMatrixFG=^THeapMatrixFG;
 THeapMatrixFG=object(TMatrixF)
  BM:PFloatBuffer;
  constructor Init(ALines,ACols:word);
  procedure Put(Index:integer; Value:pointer);virtual;
  function Get(Index:integer):pointer;virtual;
  procedure Put2(Index1,Index2:integer; Value:pointer);virtual;
  function Get2(Index1,Index2:integer):pointer;virtual;
  function Loc(Line,Col:word):word; virtual;
  procedure Fill(First,Last:word; Var Pat); virtual;
  procedure NewSize(NewLines:word; NewCols:word);virtual;
  destructor Done;virtual;
 end;

 PHeapMatrixFS=^THeapMatrixFS;
 THeapMatrixFS=object(THeapMatrixFG)
  constructor Init(ALines,ACols:word);
  function Loc(Line,Col:word):word; virtual;
 end;

 PHeapMatrixFD=^THeapMatrixFD;
 THeapMatrixFD=object(THeapMatrixFG)
  constructor Init(ALines,ACols:word);
  function Loc(Line,Col:word):word; virtual;
 end;

 PPolinom=^TPolinom;
 TPolinom=object(TObject)
  Power:word;
  BP:PPolinomBuffer;
  function CellSize:word; virtual;
  procedure Fill(First,Last:word; Var Pat); virtual;
  constructor Init(APower:word);
  function Get(V:extended):extended;
  procedure SetK(Index:word; Value:extended);
  destructor Done;virtual;
 end;

 PMatrixInt=^TMatrixInt;
 TMatrixInt=object(TMatrix)
  function CellSize:word; virtual;
 end;

 PHeapMatrixInt=^THeapMatrixInt;
 THeapMatrixInt=object(TMatrixInt)
  BM:PWordBuffer;
  constructor Init(ALines,ACols:word);
  procedure Put(Index:integer; Value:pointer);virtual;
  function Get(Index:integer):pointer;virtual;
  function Loc(Line,Col:word):word; virtual;
  procedure Fill(First,Last:word; Var Pat); virtual;
  destructor Done;virtual;
 end;

Function EMax(E1,E2:extended):extended;
Function EMin(E1,E2:extended):extended;

Implementation
Uses Diffy;

Type PFloat=^Float;

{ ⮤ TMatrix }

Constructor TMatrix.Init(ALines,ACols:word; MType:MatrixType);
Begin
 Lines:=ALines;
 Cols:=ACols;
 MatrixType:=MType;
 Changed:=False
End;

Function TMatrix.CellSize:word;
Begin End;

Procedure TMatrix.Fill(First,Last:word; Var Pat);
var i:word;
Begin
 For i:=First to Last do Put(i,@Pat)
End;

Procedure TMatrix.NewSize(NewLines:word; NewCols:word);
Begin
 Lines:=NewLines;
 Cols:=NewCols;
End;

Function TMatrix.GetMatrixType:MatrixType;
Begin
 GetMatrixType:=MatrixType
End;

Function TMatrix.Loc(Line,Col:word):word;
Begin
 Loc:=Lines*(Col-1)+Line
End;

Procedure TMatrix.Put(Index:integer; Value:pointer);
Begin End;

Procedure TMatrix.Assign(Matrix:PMatrix);
var i:integer;
Begin
 If Compatible(Matrix) then
  For i:=1 to MinI(Lines*Cols,Matrix^.Lines*Matrix^.Cols) do
   Put(i,Matrix^.Get(i));
End;

Function TMatrix.Compatible(Matrix:PMatrix):boolean;
begin
 Compatible:=False;
 If MatrixType=StringM then begin
  If Matrix^.MatrixType=StringM then Compatible:=True
 end
 else
  If Matrix^.MatrixType in [GeneralM,SimmM,DiagM] then Compatible:=True
end;

Function TMatrix.Get(Index:integer):pointer;
Begin End;

Procedure TMatrix.Put2(Index1,Index2:integer; Value:pointer);
Begin
 Put(Loc(Index1,Index2),Value)
End;

Function TMatrix.Get2(Index1,Index2:integer):pointer;
Begin
 Get2:=Get(Loc(Index1,Index2))
End;

{ ⮤ TMatrixF }

Function TMatrixF.CellSize:word;
Begin
 CellSize:=SizeOf(Float)
End;

Procedure TMatrixF.Normalize(Regim:byte);
Var I:integer; E:Float;
Begin
 If Regim=0 then begin
  NormValue:=PFloat(Get(1))^;
  For I:=2 to Loc(Lines,Cols) do
   If Abs(PFloat(Get(I))^)>NormValue then
    NormValue:=Abs(PFloat(Get(I))^);
  For I:=1 to Loc(Lines,Cols) do begin
   E:=PFloat(Get(I))^/NormValue;
   Put(I,@E)
  end
 end
 else
  For I:=1 to Loc(Lines,Cols) do begin
   E:=PFloat(Get(I))^*NormValue;
   Put(I,@E)
  end
End;

Function TMatrixF.GetNormPower:integer;
Begin
 GetNormPower:=NormPower
End;

Procedure TMatrixF.SetNormPower(MP:integer);
Begin
 NormPower:=MP
End;

Procedure TMatrixF.NormalizePower(Regim:byte);
Var Value:extended; I,Power:integer;
    VW:array[1..5] of integer absolute Value;
Begin
 If Regim=0 then begin
  Value:=PFloat(Get(1))^;
  NormPower:=VW[5] and $7FFF;
  Dec(NormPower,16383);
  {Gtexp(Value,NormPower);}

  For I:=2 to Loc(Lines,Cols) do begin
   Value:=PFloat(Get(I))^;
   Power:=VW[5] and $7FFF;
   Dec(Power,16383);
   {Gtexp(Value,Power);}
   If Power>NormPower then NormPower:=Power
  end;

  For I:=1 to Loc(Lines,Cols) do begin
   Value:=PFloat(Get(I))^;
   If Value<>0 then begin
    If (VW[5] and $7FFF)<NormPower then Value:=0
    else Dec(VW[5],NormPower);
    Put(I,@Value)
   end
  end
 end

 else
  For I:=1 to Loc(Lines,Cols) do begin
   Value:=PFloat(Get(I))^;
   {If Value<>0 then begin}
    {Inc(VW[5],NormPower);}
    Value:=Chexp(Value,NormPower);
    Put(I,@Value)
   {end}
  end
End;

{ ⮤ THeapMatrixFG }

Constructor THeapMatrixFG.Init(ALines,ACols:word);
Var S:word;
Begin
 Inherited Init(ALines,ACols,GeneralM);
 If (ALines=0) or (ACols=0) then Fail
 else begin
  S:=Loc(ALines,ACols)+1;
  GetMem(BM,S*SizeOf(extended));
  BM^[0]:=0
 end
End;

Procedure THeapMatrixFG.NewSize(NewLines:word; NewCols:word);
var BMNew:PFloatBuffer; i,k:longint;
Begin
 If (NewLines=0) or (NewCols=0) then exit;
 i:=Loc(Lines,Cols);
 Inherited NewSize(NewLines,NewCols);
 k:=MinI(Loc(NewLines,NewCols),i);
 GetMem(BMNew,(Loc(Lines,Cols)+1)*SizeOf(extended));
 FastMoveWord(BM^,BMNew^,(k+1)*SizeOf(extended) div 2);
 FreeMem(BM,(i+1)*SizeOf(extended));
 BM:=BMNew
End;

Function THeapMatrixFG.Loc(Line,Col:word):word;assembler;
{ Loc:=Lines*(Col-1)+Line }
asm
 mov ax,Col
 dec ax
 les di,Self
 mul es:word ptr [di].THeapMatrixFG.Lines
 add ax,Line
End;

Procedure THeapMatrixFG.Put(Index:integer; Value:pointer);assembler;
{ Changed:=True;
  BM^[Index]:=PFloat(Value)^}
asm
 les di,Value
 fld es:tbyte ptr[di]
 imul ax,Index,0ah
 les di,Self
 mov es:byte ptr [di].THeapMatrixFG.Changed,01
 les di,es:[di].THeapMatrixFG.BM
 add di,ax
 fstp es:tbyte ptr [di]
 fwait
End;

Function THeapMatrixFG.Get(Index:integer):pointer;assembler;
{ Get:=@BM^[Index] }
asm
 imul ax,Index,0ah   { ax = Index*SizeOf(extended) }
 les di,Self
 les di,es:[di].THeapMatrixFG.BM  { es:di = @BM^[0] }
 add ax,di         { es:di = @BM^[Index] }
 mov dx,es
End;

Const THeapMatrix_Loc=$14;

Procedure THeapMatrixFG.Put2(Index1,Index2:integer; Value:pointer);
{assembler;}
begin
 Changed:=True;
  BM^[Loc(Index1,Index2)]:=PFloat(Value)^
  {
asm
 les di,Value
 fld es:tbyte ptr [di]
 push Index1
 push Index2
 les di,Self
 mov es:byte ptr [di].THeapMatrixFG.Changed,01
 push es
 push di
 mov di,es:[di]
 call dword ptr [di].THeapMatrix_Loc
 mov bx,0ah
 mul bx
 les di,Self
 les di,es:[di].THeapMatrixFG.BM
 add di,ax
 fstp es:tbyte ptr [di]
 fwait}
End;

Function THeapMatrixFG.Get2(Index1,Index2:integer):pointer; {assembler;}
begin
 Get2:=@BM^[Loc(Index1,Index2)] {
asm
 push Index1
 push Index2
 les di,Self
 push es
 push di
 mov di,es:[di]
 call dword ptr [di].THeapMatrix_Loc
 mov bx,0ah
 mul bx
 les di,Self
 les di,es:[di].THeapMatrixFG.BM
 add ax,di
 mov dx,es}
End;

Destructor THeapMatrixFG.Done;
Begin
 FreeMem(BM,(Loc(Lines,Cols)+1)*SizeOf(Float));
End;

Procedure THeapMatrixFG.Fill(First,Last:word; Var Pat);
Begin
 FillPatt(BM^[First], Pat, Last-First+1, CellSize)
End;

Constructor THeapMatrixFS.Init(ALines,ACols:word);
Begin
 Inherited Init(ALines,ACols);
 MatrixType:=SimmM
End;

Function THeapMatrixFS.Loc(Line,Col:word):word;assembler;
{ If Line<Col then Loc:=Line+((SQR(Col)-Col) div 2)
  else
   Loc:=Col+((SQR(Line)-Line) div 2)}
asm
 mov ax,Col
 mov cx,Line
 cmp cx,ax
 jb @1
 xchg ax,cx
@1:
 mov bx,ax
 mul bx
 sub ax,bx
 sbb dx,0
 shr ax,1
 shr dx,1
 jnc @2
 or ah,10000000b
@2:
 add ax,cx
end;

Constructor THeapMatrixFD.Init(ALines,ACols:word);
Begin
 Inherited Init(ALines,ACols);
 MatrixType:=DiagM
End;

Function THeapMatrixFD.Loc(Line,Col:word):word;
Begin
 If Line=Col then Loc:=Line else Loc:=0
End;

Constructor TStrMatrix.Init(ALines:word; AStrLen:byte);
Var S:word;
Begin
 Inherited Init(ALines,1,StringM);
 StrLen:=AStrLen+1;
 If (ALines=0) then Fail
 else begin
  S:=ALines+1;
  GetMem(BM,S*(AStrLen+1));
  BM^[0]:=#0
 end
End;

Procedure TStrMatrix.NewSize(NewLines:word; NewCols:word);
var BMNew:PByteBuffer; i,k:integer;
Begin
 If (NewLines=0) or (NewCols=0) then exit;
 k:=MinI(NewCols+1,StrLen);
 GetMem(BMNew,(NewLines+1)*(NewCols+1));
 For i:=0 to MinI(Lines,NewLines) do begin
  FastMove(BM^[i*StrLen],BMNew^[i*(NewCols+1)],k);
  If byte(BMNew^[i*(NewCols+1)])>NewCols then byte(BMNew^[i*(NewCols+1)]):=NewCols;
 end;
 FreeMem(BM,(Lines+1)*StrLen);
 BM:=BMNew;
 Inherited NewSize(NewLines,1);
 StrLen:=NewCols+1;
 BM^[0]:=#0
End;

Procedure StrMove(S:string; Var Dest; MaxLen:word);assembler;
asm
 push ds
 lds si,S
 les di,Dest
 xor cx,cx
 mov cl,[si]
 mov ax,MaxLen
 cmp cx,ax
 jb @2
 xchg cx,ax
@2:
 mov es:[di],cl
 jcxz @1
 inc si
 inc di
 cld
 rep movsb
@1:
 pop ds
End;

Procedure TStrMatrix.Put(Index:integer; Value:pointer);
Begin
 If Index<=Lines then StrMove(PString(Value)^,BM^[Index*StrLen],StrLen);
 {FastMove(PString(Value)^,BM^[Index*StrLen],byte(PString(Value)^[0])+1)}
End;

Function TStrMatrix.Get(Index:integer):pointer;
Begin
 Get:=@BM^[Index*StrLen]
End;

Destructor TStrMatrix.Done;
Begin
 FreeMem(BM,(Lines+1)*StrLen)
End;


Constructor TPolinom.Init(APower:word);
Begin
 Power:=APower;
 GetMem(BP,(APower+1)*SizeOf(extended))
End;

Function TPolinom.CellSize:word;
Begin
 CellSize:=SizeOf(extended)
End;

Destructor TPolinom.Done;
Begin
 FreeMem(BP,(Power+1)*SizeOf(extended))
End;

Procedure TPolinom.Fill(First,Last:word; Var Pat);
Begin
 FillPatt(BP^[First], Pat, Last-First+1, CellSize)
End;

Procedure TPolinom.SetK(Index:word; Value:extended);
Begin
 BP^[Index]:=Value
End;

Function TPolinom.Get(V:extended):extended;
Var I:word; M:extended;
Begin
 M:=BP^[Power];
 For I:=Power-1 downto 0 do M:=M*V+BP^[I];
 Get:=M
End;

Function EMax(E1,E2:extended):extended;
Begin
 If E1>E2 then EMax:=E1 else EMax:=E2
End;

Function EMin(E1,E2:extended):extended;
Begin
 If E1<E2 then EMin:=E1 else EMin:=E2
End;

Function TMatrixInt.CellSize:word;
Begin
 CellSize:=SizeOf(integer)
End;

Constructor THeapMatrixInt.Init(ALines,ACols:word);
Var S:word;
Begin
 Inherited Init(ALines,ACols,GeneralM);
 If (ALines=0) or (ACols=0) then Fail
 else begin
  S:=Loc(ALines,ACols)+1;
  GetMem(BM,S*SizeOf(integer));
  BM^[0]:=0
 end
End;

Function THeapMatrixInt.Loc(Line,Col:word):word;assembler;
{ Loc:=Lines*(Col-1)+Line }
asm
 mov ax,Col
 dec ax
 les di,Self
 mul es:word ptr [di].THeapMatrixInt.Lines
 add ax,Line
End;

Procedure THeapMatrixInt.Put(Index:integer; Value:pointer);assembler;
{Begin
 Changed:=True;
 BM^[Index]:=Word(Longint(Value))
End;}
asm
 mov ax,Index
 shl ax,1
 les di,Self
 mov es:byte ptr [di].THeapMatrixInt.Changed,01
 les di,es:[di].THeapMatrixInt.BM
 add di,ax
 mov bx,Value.word[0]
 mov es:[di],bx
End;

Function THeapMatrixInt.Get(Index:integer):pointer;assembler;
{ Get:=@BM^[Index] }
asm
 mov ax,Index   { ax = Index*SizeOf(integer) }
 shl ax,1
 les di,Self
 les di,es:[di].THeapMatrixInt.BM  { es:di = @BM^[0] }
 add ax,di         { es:di = @BM^[Index] }
 mov dx,es
End;

Destructor THeapMatrixInt.Done;
Begin
 FreeMem(BM,(Loc(Lines,Cols)+1)*SizeOf(integer));
End;

Procedure THeapMatrixInt.Fill(First,Last:word; Var Pat);
Begin
 FillPatt(BM^[First], Pat, Last-First+1, CellSize)
End;

End.
